diff -urN -x compile -x LINT vendor/freebsd/src/sys/net/netisr.c user/rwatson/tcp/src/sys/net/netisr.c
--- vendor/freebsd/src/sys/net/netisr.c	2011-02-01 09:38:35.429142931 +0000
+++ user/rwatson/tcp/src/sys/net/netisr.c	2011-02-02 15:57:49.833777034 +0000
@@ -1,6 +1,6 @@
 /*-
  * Copyright (c) 2007-2009 Robert N. M. Watson
- * Copyright (c) 2010 Juniper Networks, Inc.
+ * Copyright (c) 2010-2011 Juniper Networks, Inc.
  * All rights reserved.
  *
  * This software was developed by Robert N. M. Watson under contract
@@ -94,6 +94,31 @@
 #include <net/netisr_internal.h>
 #include <net/vnet.h>
 
+/*
+ * Locking strategy: three types of locks protect netisr processing:
+ *
+ * netisr configuration lock - serializes "rethreading" events, in which the
+ * number of worker threads is changed.
+ *
+ * netisr_rmlock - stabilizes the netisr system for network processing,
+ * almost always acquired as a read lock (except during configuration
+ * changes).
+ *
+ * nws_mtx - per-workstream lock that serializes access to queues.
+ */
+
+/*
+ * netisr configuration lock: serialize rethread events, in which the thread
+ * count may be increased and decreased, to avoid interlacing of these
+ * events, which might expose incompletely started or stopped threads, etc.
+ * This is a sleep lock so that it can be held over ithread start/stop.
+ */
+static struct sx netisr_config_sx;
+#define	NETISR_CONFIG_LOCK_INIT()	sx_init(&netisr_config_sx,	\
+					    "netisr_config_sx")
+#define	NETISR_CONFIG_LOCK()		sx_xlock(&netisr_config_sx)
+#define	NETISR_CONFIG_UNLOCK()		sx_xunlock(&netisr_config_sx)
+
 /*-
  * Synchronize use and modification of the registered netisr data structures;
  * acquire a read lock while modifying the set of registered protocols to
@@ -114,51 +139,74 @@
  *
  * XXXRW: rmlocks don't support assertions.
  */
+#define	NETISR_RMLOCKING
+
+#ifdef NETISR_RMLOCKING
 static struct rmlock	netisr_rmlock;
 #define	NETISR_LOCK_INIT()	rm_init_flags(&netisr_rmlock, "netisr", \
-				    RM_NOWITNESS)
+				    RM_NOWITNESS | RM_RECURSE)
 #define	NETISR_LOCK_ASSERT()
 #define	NETISR_RLOCK(tracker)	rm_rlock(&netisr_rmlock, (tracker))
 #define	NETISR_RUNLOCK(tracker)	rm_runlock(&netisr_rmlock, (tracker))
 #define	NETISR_WLOCK()		rm_wlock(&netisr_rmlock)
 #define	NETISR_WUNLOCK()	rm_wunlock(&netisr_rmlock)
-/* #define	NETISR_LOCKING */
+#else
+#define	NETISR_LOCK_INIT()
+#define	NETISR_LOCK_ASSERT()
+#define	NETISR_RLOCK(x)
+#define	NETISR_RUNLOCK(x)
+#define	NETISR_WLOCK()
+#define	NETISR_WUNLOCK()
+#endif
 
 SYSCTL_NODE(_net, OID_AUTO, isr, CTLFLAG_RW, 0, "netisr");
 
 /*-
- * Three direct dispatch policies are supported:
+ * Three global direct dispatch policies are supported:
  *
- * - Always defer: all work is scheduled for a netisr, regardless of context.
- *   (!direct)
+ * NETISR_DISPATCH_QUEUED: All work is deferred for a netisr, regardless of
+ * context (may be overriden by protocols).
  *
- * - Hybrid: if the executing context allows direct dispatch, and we're
- *   running on the CPU the work would be done on, then direct dispatch if it
- *   wouldn't violate ordering constraints on the workstream.
- *   (direct && !direct_force)
+ * NETISR_DISPATCH_HYBRID: If the executing context allows direct dispatch,
+ * and we're running on the CPU the work would be performed on, then direct
+ * dispatch it if it wouldn't violate ordering constraints on the workstream.
  *
- * - Always direct: if the executing context allows direct dispatch, always
- *   direct dispatch.  (direct && direct_force)
+ * NETISR_DISPATCH_DIRECT: If the executing context allows direct dispatch,
+ * always direct dispatch.  (The default.)
  *
  * Notice that changing the global policy could lead to short periods of
  * misordered processing, but this is considered acceptable as compared to
- * the complexity of enforcing ordering during policy changes.
- */
-static int	netisr_direct_force = 1;	/* Always direct dispatch. */
-TUNABLE_INT("net.isr.direct_force", &netisr_direct_force);
-SYSCTL_INT(_net_isr, OID_AUTO, direct_force, CTLFLAG_RW,
-    &netisr_direct_force, 0, "Force direct dispatch");
-
-static int	netisr_direct = 1;	/* Enable direct dispatch. */
-TUNABLE_INT("net.isr.direct", &netisr_direct);
-SYSCTL_INT(_net_isr, OID_AUTO, direct, CTLFLAG_RW,
-    &netisr_direct, 0, "Enable direct dispatch");
-
-/*
- * Allow the administrator to limit the number of threads (CPUs) to use for
- * netisr.  We don't check netisr_maxthreads before creating the thread for
- * CPU 0, so in practice we ignore values <= 1.  This must be set at boot.
- * We will create at most one thread per CPU.
+ * the complexity of enforcing ordering during policy changes.  Protocols can
+ * override the global policy (when they're not doing that, they select
+ * NETISR_DISPATCH_DEFAULT).
+ */
+#define	NETISR_DISPATCH_POLICY_DEFAULT	NETISR_DISPATCH_DIRECT
+#define	NETISR_DISPATCH_POLICY_MAXSTR	20 /* Used for temporary buffers. */
+static u_int	netisr_dispatch_policy = NETISR_DISPATCH_POLICY_DEFAULT;
+static int	sysctl_netisr_dispatch_policy(SYSCTL_HANDLER_ARGS);
+SYSCTL_PROC(_net_isr, OID_AUTO, dispatch, CTLTYPE_STRING | CTLFLAG_RW |
+    CTLFLAG_TUN, 0, 0, sysctl_netisr_dispatch_policy, "A",
+    "netisr dispatch policy");
+
+/*
+ * These sysctls were used in previous versions to control and export
+ * dispatch policy state.  Now, we provide read-only export via them so that
+ * older netstat binaries work.  At some point they can be garbage collected.
+ */
+static int	netisr_direct_force;
+SYSCTL_INT(_net_isr, OID_AUTO, direct_force, CTLFLAG_RD,
+    &netisr_direct_force, 0, "compat: force direct dispatch");
+
+static int	netisr_direct;
+SYSCTL_INT(_net_isr, OID_AUTO, direct, CTLFLAG_RD, &netisr_direct, 0,
+    "compat: enable direct dispatch");
+
+/*
+ * Maximum numbe of threads to be used by netisr; will be capped to the
+ * number of CPUs, or set to the number of CPUs if the default of '-1' is
+ * present.  In the future, if we allow the stack/schedule to adjust the
+ * number of threads dynamically then this will allow the administrator to
+ * tune that behavior.
  */
 static int	netisr_maxthreads = -1;		/* Max number of threads. */
 TUNABLE_INT("net.isr.maxthreads", &netisr_maxthreads);
@@ -166,15 +214,30 @@
     &netisr_maxthreads, 0,
     "Use at most this many CPUs for netisr processing");
 
+/*
+ * The default number of threads to use at boot, which will be capped to
+ * maxthreads.  We default to 1 for now.
+ */
+#define	NETISR_DEFAULT_DEFAULTTHREADS	1
+static int	netisr_defaultthreads = NETISR_DEFAULT_DEFAULTTHREADS;
+TUNABLE_INT("net.isr.defaultthreads", &netisr_defaultthreads);
+SYSCTL_INT(_net_isr, OID_AUTO, defaultthreads, CTLFLAG_RD,
+    &netisr_defaultthreads, 0,
+    "Use this many CPUs for netisr processing by default");
+
+/*
+ * Bind workstream threads to CPUs.  For now, we allow things to float
+ * around by default, but as our notions of CPU affinity get stronger, we may
+ * want to change this policy.
+ */
 static int	netisr_bindthreads = 0;		/* Bind threads to CPUs. */
 TUNABLE_INT("net.isr.bindthreads", &netisr_bindthreads);
 SYSCTL_INT(_net_isr, OID_AUTO, bindthreads, CTLFLAG_RDTUN,
     &netisr_bindthreads, 0, "Bind netisr threads to CPUs.");
 
 /*
- * Limit per-workstream mbuf queue limits s to at most net.isr.maxqlimit,
- * both for initial configuration and later modification using
- * netisr_setqlimit().
+ * Limit per-workstream mbuf queue limits to at most net.isr.maxqlimit, both
+ * for initial configuration and later modification using netisr_setqlimit().
  */
 #define	NETISR_DEFAULT_MAXQLIMIT	10240
 static u_int	netisr_maxqlimit = NETISR_DEFAULT_MAXQLIMIT;
@@ -225,11 +288,10 @@
 
 /*
  * Number of registered workstreams.  Will be at most the number of running
- * CPUs once fully started.
+ * CPUs once fully started.  To modify this, must hold both of
+ * netisr_config_sx and netisr_rm for write.
  */
 static u_int				 nws_count;
-SYSCTL_INT(_net_isr, OID_AUTO, numthreads, CTLFLAG_RD,
-    &nws_count, 0, "Number of extant netisr threads.");
 
 /*
  * Synchronization for each workstream: a mutex protects all mutable fields
@@ -276,6 +338,103 @@
 }
 
 /*
+ * Dispatch tunable and sysctl configuration.
+ */
+struct netisr_dispatch_table_entry {
+	u_int		 ndte_policy;
+	const char	*ndte_policy_str;
+};
+static const struct netisr_dispatch_table_entry netisr_dispatch_table[] = {
+	{ NETISR_DISPATCH_DEFAULT, "default" },
+	{ NETISR_DISPATCH_DEFERRED, "deferred" },
+	{ NETISR_DISPATCH_HYBRID, "hybrid" },
+	{ NETISR_DISPATCH_DIRECT, "direct" },
+};
+static const u_int netisr_dispatch_table_len =
+    (sizeof(netisr_dispatch_table) / sizeof(netisr_dispatch_table[0]));
+
+static void
+netisr_dispatch_policy_to_str(u_int dispatch_policy, char *buffer,
+    u_int buflen)
+{
+	const struct netisr_dispatch_table_entry *ndtep;
+	const char *str;
+	u_int i;
+
+	str = "unknown";
+	for (i = 0; i < netisr_dispatch_table_len; i++) {
+		ndtep = &netisr_dispatch_table[i];
+		if (ndtep->ndte_policy == dispatch_policy) {
+			str = ndtep->ndte_policy_str;
+			break;
+		}
+	}
+	snprintf(buffer, buflen, "%s", str);
+}
+
+static int
+netisr_dispatch_policy_from_str(const char *str, u_int *dispatch_policyp)
+{
+	const struct netisr_dispatch_table_entry *ndtep;
+	u_int i;
+
+	for (i = 0; i < netisr_dispatch_table_len; i++) {
+		ndtep = &netisr_dispatch_table[i];
+		if (strcmp(ndtep->ndte_policy_str, str) == 0) {
+			*dispatch_policyp = ndtep->ndte_policy;
+			return (0);
+		}
+	}
+	return (EINVAL);
+}
+
+static void
+netisr_dispatch_policy_compat(void)
+{
+
+	switch (netisr_dispatch_policy) {
+	case NETISR_DISPATCH_DEFERRED:
+		netisr_direct_force = 0;
+		netisr_direct = 0;
+		break;
+
+	case NETISR_DISPATCH_HYBRID:
+		netisr_direct_force = 0;
+		netisr_direct = 1;
+		break;
+
+	case NETISR_DISPATCH_DIRECT:
+		netisr_direct_force = 1;
+		netisr_direct = 1;
+		break;
+
+	default:
+		panic("netisr_dispatch_policy_compat: unknown policy");
+	}
+}
+
+static int
+sysctl_netisr_dispatch_policy(SYSCTL_HANDLER_ARGS)
+{
+	char tmp[NETISR_DISPATCH_POLICY_MAXSTR];
+	u_int dispatch_policy;
+	int error;
+
+	netisr_dispatch_policy_to_str(netisr_dispatch_policy, tmp,
+	    sizeof(tmp));
+	error = sysctl_handle_string(oidp, tmp, sizeof(tmp), req);
+	if (error == 0 && req->newptr != NULL) {
+		error = netisr_dispatch_policy_from_str(tmp,
+		    &dispatch_policy);
+		if (error == 0) {
+			netisr_dispatch_policy = dispatch_policy;
+			netisr_dispatch_policy_compat();
+		}
+	}
+	return (error);
+}
+
+/*
  * Register a new netisr handler, which requires initializing per-protocol
  * fields for each workstream.  All netisr work is briefly suspended while
  * the protocol is installed.
@@ -312,6 +471,12 @@
 	KASSERT(nhp->nh_policy != NETISR_POLICY_CPU || nhp->nh_m2cpuid != NULL,
 	    ("%s: nh_policy == CPU but m2cpuid not defined for %s", __func__,
 	    name));
+	KASSERT(nhp->nh_dispatch == NETISR_DISPATCH_DEFAULT ||
+	    nhp->nh_dispatch == NETISR_DISPATCH_DEFERRED ||
+	    nhp->nh_dispatch == NETISR_DISPATCH_HYBRID ||
+	    nhp->nh_dispatch == NETISR_DISPATCH_DIRECT,
+	    ("%s: invalid nh_dispatch (%u)", __func__, nhp->nh_dispatch));
+
 	KASSERT(proto < NETISR_MAXPROT,
 	    ("%s(%u, %s): protocol too big", __func__, proto, name));
 
@@ -339,6 +504,7 @@
 	} else
 		netisr_proto[proto].np_qlimit = nhp->nh_qlimit;
 	netisr_proto[proto].np_policy = nhp->nh_policy;
+	netisr_proto[proto].np_dispatch = nhp->nh_dispatch;
 	for (i = 0; i <= mp_maxid; i++) {
 		if (CPU_ABSENT(i))
 			continue;
@@ -389,7 +555,9 @@
 netisr_getqdrops(const struct netisr_handler *nhp, u_int64_t *qdropp)
 {
 	struct netisr_work *npwp;
+#ifdef NETISR_RMLOCKING
 	struct rm_priotracker tracker;
+#endif
 #ifdef INVARIANTS
 	const char *name;
 #endif
@@ -423,7 +591,9 @@
 void
 netisr_getqlimit(const struct netisr_handler *nhp, u_int *qlimitp)
 {
+#ifdef NETISR_RMLOCKING
 	struct rm_priotracker tracker;
+#endif
 #ifdef INVARIANTS
 	const char *name;
 #endif
@@ -551,15 +721,35 @@
 }
 
 /*
+ * Compose the global and per-protocol policies on dispatch, and return the
+ * dispatch policy to use.
+ *
+ * XXXRW: Rename these sysctls to make it clear they are selecting a default,
+ * and to use the same policy naming scheme.
+ */
+static u_int
+netisr_get_dispatch(struct netisr_proto *npp)
+{
+
+	/*
+	 * Protocol-specific configuration overrides the global default.
+	 */
+	if (npp->np_dispatch != NETISR_DISPATCH_DEFAULT)
+		return (npp->np_dispatch);
+	return (netisr_dispatch_policy);
+}
+
+/*
  * Look up the workstream given a packet and source identifier.  Do this by
  * checking the protocol's policy, and optionally call out to the protocol
  * for assistance if required.
  */
 static struct mbuf *
-netisr_select_cpuid(struct netisr_proto *npp, uintptr_t source,
-    struct mbuf *m, u_int *cpuidp)
+netisr_select_cpuid(struct netisr_proto *npp, u_int dispatch_policy,
+    uintptr_t source, struct mbuf *m, u_int *cpuidp)
 {
 	struct ifnet *ifp;
+	u_int policy;
 
 	NETISR_LOCK_ASSERT();
 
@@ -577,11 +767,30 @@
 	 * If we want to support per-interface policies, we should do that
 	 * here first.
 	 */
-	switch (npp->np_policy) {
-	case NETISR_POLICY_CPU:
-		return (npp->np_m2cpuid(m, source, cpuidp));
+	policy = npp->np_policy;
+	if (policy == NETISR_POLICY_CPU) {
+		m = npp->np_m2cpuid(m, source, cpuidp);
+		if (m == NULL)
+			return (NULL);
+
+		/*
+		 * It's possible for a protocol not to have a good idea about
+		 * where to process a packet, in which case we fall back on
+		 * the netisr code to decide.  In the hybrid case, return the
+		 * current CPU ID, which will force an immediate direct
+		 * dispatch.  In the queued case, fall back on the SOURCE
+		 * policy.
+		 */
+		if (*cpuidp != NETISR_CPUID_NONE)
+			return (m);
+		if (dispatch_policy == NETISR_DISPATCH_HYBRID) {
+			*cpuidp = curcpu;
+			return (m);
+		}
+		policy = NETISR_POLICY_SOURCE;
+	}
 
-	case NETISR_POLICY_FLOW:
+	if (policy == NETISR_POLICY_FLOW) {
 		if (!(m->m_flags & M_FLOWID) && npp->np_m2flow != NULL) {
 			m = npp->np_m2flow(m, source);
 			if (m == NULL)
@@ -592,21 +801,19 @@
 			    netisr_default_flow2cpu(m->m_pkthdr.flowid);
 			return (m);
 		}
-		/* FALLTHROUGH */
-
-	case NETISR_POLICY_SOURCE:
-		ifp = m->m_pkthdr.rcvif;
-		if (ifp != NULL)
-			*cpuidp = nws_array[(ifp->if_index + source) %
-			    nws_count];
-		else
-			*cpuidp = nws_array[source % nws_count];
-		return (m);
-
-	default:
-		panic("%s: invalid policy %u for %s", __func__,
-		    npp->np_policy, npp->np_name);
+		policy = NETISR_POLICY_SOURCE;
 	}
+
+	KASSERT(policy == NETISR_POLICY_SOURCE,
+	    ("%s: invalid policy %u for %s", __func__, npp->np_policy,
+	    npp->np_name));
+
+	ifp = m->m_pkthdr.rcvif;
+	if (ifp != NULL)
+		*cpuidp = nws_array[(ifp->if_index + source) % nws_count];
+	else
+		*cpuidp = nws_array[source % nws_count];
+	return (m);
 }
 
 /*
@@ -680,7 +887,7 @@
 static void
 swi_net(void *arg)
 {
-#ifdef NETISR_LOCKING
+#ifdef NETISR_RMLOCKING
 	struct rm_priotracker tracker;
 #endif
 	struct netisr_workstream *nwsp;
@@ -693,9 +900,7 @@
 	    ("%s: device_polling but nws_count != 1", __func__));
 	netisr_poll();
 #endif
-#ifdef NETISR_LOCKING
 	NETISR_RLOCK(&tracker);
-#endif
 	NWS_LOCK(nwsp);
 	KASSERT(!(nwsp->nws_flags & NWS_RUNNING), ("swi_net: running"));
 	if (nwsp->nws_flags & NWS_DISPATCHING)
@@ -712,9 +917,7 @@
 	nwsp->nws_flags &= ~NWS_RUNNING;
 out:
 	NWS_UNLOCK(nwsp);
-#ifdef NETISR_LOCKING
 	NETISR_RUNLOCK(&tracker);
-#endif
 #ifdef DEVICE_POLLING
 	netisr_pollmore();
 #endif
@@ -767,9 +970,7 @@
 	struct netisr_work *npwp;
 	int dosignal, error;
 
-#ifdef NETISR_LOCKING
 	NETISR_LOCK_ASSERT();
-#endif
 	KASSERT(cpuid <= mp_maxid, ("%s: cpuid too big (%u, %u)", __func__,
 	    cpuid, mp_maxid));
 	KASSERT(!CPU_ABSENT(cpuid), ("%s: CPU %u absent", __func__, cpuid));
@@ -789,7 +990,7 @@
 int
 netisr_queue_src(u_int proto, uintptr_t source, struct mbuf *m)
 {
-#ifdef NETISR_LOCKING
+#ifdef NETISR_RMLOCKING
 	struct rm_priotracker tracker;
 #endif
 	u_int cpuid;
@@ -798,22 +999,19 @@
 	KASSERT(proto < NETISR_MAXPROT,
 	    ("%s: invalid proto %u", __func__, proto));
 
-#ifdef NETISR_LOCKING
 	NETISR_RLOCK(&tracker);
-#endif
 	KASSERT(netisr_proto[proto].np_handler != NULL,
 	    ("%s: invalid proto %u", __func__, proto));
 
-	m = netisr_select_cpuid(&netisr_proto[proto], source, m, &cpuid);
+	m = netisr_select_cpuid(&netisr_proto[proto], NETISR_DISPATCH_DEFERRED,
+	    source, m, &cpuid);
 	if (m != NULL) {
 		KASSERT(!CPU_ABSENT(cpuid), ("%s: CPU %u absent", __func__,
 		    cpuid));
 		error = netisr_queue_internal(proto, m, cpuid);
 	} else
 		error = ENOBUFS;
-#ifdef NETISR_LOCKING
 	NETISR_RUNLOCK(&tracker);
-#endif
 	return (error);
 }
 
@@ -831,27 +1029,27 @@
 int
 netisr_dispatch_src(u_int proto, uintptr_t source, struct mbuf *m)
 {
-#ifdef NETISR_LOCKING
+#ifdef NETISR_RMLOCKING
 	struct rm_priotracker tracker;
 #endif
 	struct netisr_workstream *nwsp;
+	struct netisr_proto *npp;
 	struct netisr_work *npwp;
 	int dosignal, error;
-	u_int cpuid;
-
-	/*
-	 * If direct dispatch is entirely disabled, fall back on queueing.
-	 */
-	if (!netisr_direct)
-		return (netisr_queue_src(proto, source, m));
+	u_int cpuid, dispatch_policy;
 
 	KASSERT(proto < NETISR_MAXPROT,
 	    ("%s: invalid proto %u", __func__, proto));
-#ifdef NETISR_LOCKING
+
 	NETISR_RLOCK(&tracker);
-#endif
-	KASSERT(netisr_proto[proto].np_handler != NULL,
-	    ("%s: invalid proto %u", __func__, proto));
+	npp = &netisr_proto[proto];
+
+	KASSERT(npp->np_handler != NULL, ("%s: invalid proto %u", __func__,
+	    proto));
+
+	dispatch_policy = netisr_get_dispatch(npp);
+	if (dispatch_policy == NETISR_DISPATCH_DEFERRED)
+		return (netisr_queue_src(proto, source, m));
 
 	/*
 	 * If direct dispatch is forced, then unconditionally dispatch
@@ -860,7 +1058,7 @@
 	 * nws_flags because all netisr processing will be source ordered due
 	 * to always being forced to directly dispatch.
 	 */
-	if (netisr_direct_force) {
+	if (dispatch_policy == NETISR_DISPATCH_DIRECT) {
 		nwsp = DPCPU_PTR(nws);
 		npwp = &nwsp->nws_work[proto];
 		npwp->nw_dispatched++;
@@ -870,18 +1068,22 @@
 		goto out_unlock;
 	}
 
+	KASSERT(dispatch_policy == NETISR_DISPATCH_HYBRID,
+	    ("%s: unknown dispatch policy (%u)", __func__, dispatch_policy));
+
 	/*
 	 * Otherwise, we execute in a hybrid mode where we will try to direct
 	 * dispatch if we're on the right CPU and the netisr worker isn't
 	 * already running.
 	 */
-	m = netisr_select_cpuid(&netisr_proto[proto], source, m, &cpuid);
+	sched_pin();
+	m = netisr_select_cpuid(&netisr_proto[proto], NETISR_DISPATCH_HYBRID,
+	    source, m, &cpuid);
 	if (m == NULL) {
 		error = ENOBUFS;
-		goto out_unlock;
+		goto out_unpin;
 	}
 	KASSERT(!CPU_ABSENT(cpuid), ("%s: CPU %u absent", __func__, cpuid));
-	sched_pin();
 	if (cpuid != curcpu)
 		goto queue_fallback;
 	nwsp = DPCPU_PTR(nws);
@@ -942,9 +1144,7 @@
 out_unpin:
 	sched_unpin();
 out_unlock:
-#ifdef NETISR_LOCKING
 	NETISR_RUNLOCK(&tracker);
-#endif
 	return (error);
 }
 
@@ -971,63 +1171,127 @@
 }
 #endif
 
+/*
+ * Given a status quo, adjust the number of threads to match the requested
+ * configuration.  Any policy blending thread resource limits, CPU count,
+ * etc, must be imposed by the caller and is assumed already done here.
+ */
 static void
-netisr_start_swi(u_int cpuid, struct pcpu *pc)
+netisr_adjust_threads(int nws_desired)
 {
-	char swiname[12];
 	struct netisr_workstream *nwsp;
+	u_int cpuid, nwsid, nws_oldcount;
+	char swiname[12];
 	int error;
 
-	KASSERT(!CPU_ABSENT(cpuid), ("%s: CPU %u absent", __func__, cpuid));
+	NETISR_CONFIG_LOCK();
+	nws_oldcount = nws_count;
 
-	nwsp = DPCPU_ID_PTR(cpuid, nws);
-	mtx_init(&nwsp->nws_mtx, "netisr_mtx", NULL, MTX_DEF);
-	nwsp->nws_cpu = cpuid;
-	snprintf(swiname, sizeof(swiname), "netisr %u", cpuid);
-	error = swi_add(&nwsp->nws_intr_event, swiname, swi_net, nwsp,
-	    SWI_NET, INTR_MPSAFE, &nwsp->nws_swi_cookie);
-	if (error)
-		panic("%s: swi_add %d", __func__, error);
-	pc->pc_netisr = nwsp->nws_intr_event;
-	if (netisr_bindthreads) {
-		error = intr_event_bind(nwsp->nws_intr_event, cpuid);
-		if (error != 0)
-			printf("%s: cpu %u: intr_event_bind: %d", __func__,
-			    cpuid, error);
+	/*
+	 * Add new threads required before hooking them up.
+	 */
+	for (nwsid = nws_oldcount; nwsid < nws_desired; nwsid++) {
+		cpuid = nws_array[nwsid];
+		nwsp = DPCPU_ID_PTR(cpuid, nws);
+		KASSERT(nwsp->nws_intr_event == NULL,
+		    ("%s: nws_intr_event CPU %u non-NULL", __func__, cpuid));
+		snprintf(swiname, sizeof(swiname), "netisr %u", nwsid);
+		error = swi_add(&nwsp->nws_intr_event, swiname, swi_net,
+		    nwsp, SWI_NET, INTR_MPSAFE, &nwsp->nws_swi_cookie);
+		if (error)
+			panic("%s: swi_add %d", __func__, error);
+		if (netisr_bindthreads) {
+			error = intr_event_bind(nwsp->nws_intr_event, cpuid);
+			if (error)
+				printf("%s: cpu %u: intr_event_bind: %d",
+				    __func__, cpuid, error);
+		}
 	}
+
+	/*
+	 * Suspend netisr processing; mostly drains queues, prevents new work
+	 * from being scheduled.
+	 */
 	NETISR_WLOCK();
-	nws_array[nws_count] = nwsp->nws_cpu;
-	nws_count++;
+
+	/*
+	 * XXXRW: Is there any drain activity we can perform here to address
+	 * the race between swi_sched() and netisr_lock() in the swi?  We
+	 * can't recurse the rmlock by acquiring it read after write, so we
+	 * can't just walk the workstreams and process pending packets.  This
+	 * could occur if the protocol calls back into netisr to schedule new
+	 * work, for example.  Possibly we need a more complex solution?  Or
+	 * should we just drain the queues and drop the packets...
+	 */
+
+	/*
+	 * Update worker count and resume processing.
+	 */
+	nws_count = nws_desired;
 	NETISR_WUNLOCK();
+
+	/*
+	 * Remove threads that are now no longer in use.
+	 */
+	for (nwsid = nws_desired; nwsid < nws_oldcount; nwsid++) {
+		cpuid = nws_array[nwsid];
+		nwsp = DPCPU_ID_PTR(cpuid, nws);
+		error = swi_remove(nwsp->nws_swi_cookie);
+		if (error)
+			panic("%s: swi_remove %d", __func__, error);
+		nwsp->nws_intr_event = NULL;
+	}
+
+	NETISR_CONFIG_UNLOCK();
 }
 
 /*
  * Initialize the netisr subsystem.  We rely on BSS and static initialization
  * of most fields in global data structures.
  *
- * Start a worker thread for the boot CPU so that we can support network
- * traffic immediately in case the network stack is used before additional
- * CPUs are started (for example, diskless boot).
+ * Initialize workstream state for all CPUs, but start a worker only for the
+ * boot CPU.  That way we can support network traffic immediately in case the
+ * stack is used before additional CPUs are started (for example, diskless
+ * boot).
  */
 static void
 netisr_init(void *arg)
 {
+	char tmp[NETISR_DISPATCH_POLICY_MAXSTR];
+	struct netisr_workstream *nwsp;
+	u_int cpuid, dispatch_policy, nwsid;
 
 	KASSERT(curcpu == 0, ("%s: not on CPU 0", __func__));
 
+	/*
+	 * Initialize global locks.
+	 */
 	NETISR_LOCK_INIT();
+	NETISR_CONFIG_LOCK_INIT();
+
+	/*
+	 * Digest pre-boot policy and configuration.
+	 */
 	if (netisr_maxthreads < 1)
-		netisr_maxthreads = 1;
+		netisr_maxthreads = mp_ncpus;
+	if (netisr_defaultthreads < 1)
+		netisr_defaultthreads = NETISR_DEFAULT_DEFAULTTHREADS;
 	if (netisr_maxthreads > mp_ncpus) {
 		printf("netisr_init: forcing maxthreads from %d to %d\n",
 		    netisr_maxthreads, mp_ncpus);
 		netisr_maxthreads = mp_ncpus;
 	}
+	if (netisr_defaultthreads > netisr_maxthreads) {
+		printf("netisr_init: forcing defaultthreads from %d to %d\n",
+		    netisr_defaultthreads, netisr_maxthreads);
+		netisr_defaultthreads = netisr_maxthreads;
+	}
 	if (netisr_defaultqlimit > netisr_maxqlimit) {
 		printf("netisr_init: forcing defaultqlimit from %d to %d\n",
 		    netisr_defaultqlimit, netisr_maxqlimit);
 		netisr_defaultqlimit = netisr_maxqlimit;
 	}
+
 #ifdef DEVICE_POLLING
 	/*
 	 * The device polling code is not yet aware of how to deal with
@@ -1042,30 +1306,47 @@
 	}
 #endif
 
-	netisr_start_swi(curcpu, pcpu_find(curcpu));
+	TUNABLE_STR_FETCH("net.isr.dispatch", tmp, sizeof(tmp));
+	if (strlen(tmp) != 0) {
+		if (netisr_dispatch_policy_from_str(tmp, &dispatch_policy)
+		    == 0) {
+			netisr_dispatch_policy = dispatch_policy;
+			netisr_dispatch_policy_compat();
+		} else
+			printf(
+			    "%s: invalid dispatch policy %s, using default\n",
+			    __func__, tmp);
+	}
+
+	/*
+	 * Initialize workstream data structures, populate nws_array, but
+	 * don't start threads yet as the APs aren't started yet.
+	 */
+	for (cpuid = 0, nwsid = 0; cpuid < MAXCPU; cpuid++) {
+		if (CPU_ABSENT(cpuid))
+			continue;
+		nwsp = DPCPU_ID_PTR(cpuid, nws);
+		mtx_init(&nwsp->nws_mtx, "netisr_mtx", NULL, MTX_DEF);
+		nwsp->nws_cpu = cpuid;
+		nws_array[nwsid] = cpuid;
+		nwsid++;
+	}
+
+	/*
+	 * Start a boot CPU netisr to get us going.
+	 */
+	netisr_adjust_threads(1);
 }
 SYSINIT(netisr_init, SI_SUB_SOFTINTR, SI_ORDER_FIRST, netisr_init, NULL);
 
 /*
- * Start worker threads for additional CPUs.  No attempt to gracefully handle
- * work reassignment, we don't yet support dynamic reconfiguration.
+ * Now that SMP is going, create any additional threads we may require.
  */
 static void
 netisr_start(void *arg)
 {
-	struct pcpu *pc;
 
-	SLIST_FOREACH(pc, &cpuhead, pc_allcpu) {
-		if (nws_count >= netisr_maxthreads)
-			break;
-		/* XXXRW: Is skipping absent CPUs still required here? */
-		if (CPU_ABSENT(pc->pc_cpuid))
-			continue;
-		/* Worker will already be present for boot CPU. */
-		if (pc->pc_netisr != NULL)
-			continue;
-		netisr_start_swi(pc->pc_cpuid, pc);
-	}
+	netisr_adjust_threads(netisr_defaultthreads);
 }
 SYSINIT(netisr_start, SI_SUB_SMP, SI_ORDER_MIDDLE, netisr_start, NULL);
 
@@ -1097,6 +1378,7 @@
 		snpp->snp_proto = proto;
 		snpp->snp_qlimit = npp->np_qlimit;
 		snpp->snp_policy = npp->np_policy;
+		snpp->snp_dispatch = npp->np_dispatch;
 		if (npp->np_m2flow != NULL)
 			snpp->snp_flags |= NETISR_SNP_FLAGS_M2FLOW;
 		if (npp->np_m2cpuid != NULL)
@@ -1233,6 +1515,29 @@
     "S,sysctl_netisr_work",
     "Return list of per-workstream, per-protocol work in netisr");
 
+/*
+ * Run-time query and adjustment of thread count using a sysctl.
+ */
+static int
+sysctl_net_isr_numthreads(SYSCTL_HANDLER_ARGS)
+{
+	u_int numthreads;
+	int error;
+
+	numthreads = nws_count;
+	error = sysctl_handle_int(oidp, &numthreads, 0, req);
+	if (error || req->newptr == NULL)
+		return (error);
+	if (numthreads < 1 || numthreads > netisr_maxthreads)
+		return (EINVAL);
+	netisr_adjust_threads(numthreads);
+	return (0);
+}
+
+SYSCTL_PROC(_net_isr, OID_AUTO, numthreads, CTLTYPE_UINT|CTLFLAG_RW, 0, 0,
+    sysctl_net_isr_numthreads, "I",
+    "Number of threads used by the netisr framework");
+
 #ifdef DDB
 DB_SHOW_COMMAND(netisr, db_show_netisr)
 {
diff -urN -x compile -x LINT vendor/freebsd/src/sys/net/netisr.h user/rwatson/tcp/src/sys/net/netisr.h
--- vendor/freebsd/src/sys/net/netisr.h	2011-02-01 09:38:35.433566119 +0000
+++ user/rwatson/tcp/src/sys/net/netisr.h	2011-02-02 16:48:26.313571254 +0000
@@ -1,6 +1,6 @@
 /*-
  * Copyright (c) 2007-2009 Robert N. M. Watson
- * Copyright (c) 2010 Juniper Networks, Inc.
+ * Copyright (c) 2010-2011 Juniper Networks, Inc.
  * All rights reserved.
  *
  * This software was developed by Robert N. M. Watson under contract
@@ -71,6 +71,15 @@
 #define	NETISR_POLICY_CPU	3	/* Protocol determines CPU placement. */
 
 /*
+ * Protocol dispatch policy constants; selects whether and when direct
+ * dispatch is permitted.
+ */
+#define	NETISR_DISPATCH_DEFAULT		0	/* Use global default. */
+#define	NETISR_DISPATCH_DEFERRED	1	/* Always defer dispatch. */
+#define	NETISR_DISPATCH_HYBRID		2	/* Allow hybrid dispatch. */
+#define	NETISR_DISPATCH_DIRECT		3	/* Always direct dispatch. */
+
+/*
  * Monitoring data structures, exported by sysctl(2).
  *
  * Three sysctls are defined.  First, a per-protocol structure exported by
@@ -84,7 +93,8 @@
 	u_int	snp_qlimit;			/* nh_qlimit */
 	u_int	snp_policy;			/* nh_policy */
 	u_int	snp_flags;			/* Various flags. */
-	u_int	_snp_ispare[7];
+	u_int	snp_dispatch;			/* Dispatch policy. */
+	u_int	_snp_ispare[6];
 };
 
 /*
@@ -173,6 +183,8 @@
 typedef	struct mbuf	*netisr_m2flow_t(struct mbuf *m, uintptr_t source);
 typedef void		 netisr_drainedcpu_t(u_int cpuid);
 
+#define	NETISR_CPUID_NONE	((u_int)-1)	/* No affinity returned. */
+
 /*
  * Data structure describing a protocol handler.
  */
@@ -185,7 +197,8 @@
 	u_int		 nh_proto;	/* Integer protocol ID. */
 	u_int		 nh_qlimit;	/* Maximum per-CPU queue depth. */
 	u_int		 nh_policy;	/* Work placement policy. */
-	u_int		 nh_ispare[5];	/* For future use. */
+	u_int		 nh_dispatch;	/* Dispatch policy. */
+	u_int		 nh_ispare[4];	/* For future use. */
 	void		*nh_pspare[4];	/* For future use. */
 };
 
diff -urN -x compile -x LINT vendor/freebsd/src/sys/net/netisr_internal.h user/rwatson/tcp/src/sys/net/netisr_internal.h
--- vendor/freebsd/src/sys/net/netisr_internal.h	2011-02-01 09:38:35.433566119 +0000
+++ user/rwatson/tcp/src/sys/net/netisr_internal.h	2011-02-01 08:30:18.237856888 +0000
@@ -1,6 +1,6 @@
 /*-
  * Copyright (c) 2007-2009 Robert N. M. Watson
- * Copyright (c) 2010 Juniper Networks, Inc.
+ * Copyright (c) 2010-2011 Juniper Networks, Inc.
  * All rights reserved.
  *
  * This software was developed by Robert N. M. Watson under contract
@@ -64,6 +64,7 @@
 	netisr_drainedcpu_t *np_drainedcpu; /* Callback when drained a queue. */
 	u_int		 np_qlimit;	/* Maximum per-CPU queue depth. */
 	u_int		 np_policy;	/* Work placement policy. */
+	u_int		 np_dispatch;	/* Work dispatch policy. */
 };
 
 #define	NETISR_MAXPROT	16		/* Compile-time limit. */
